function [G_new, logQ_ratio, updated_ind] = MH_proposal_bounded_deg(G, d)
  n = G.n;

  nparent = sum(G.adj);
  full_node = find(nparent >= d);

  [i_delete, j_delete] = find(G.adj);
  [i1, j1] = find(~G.adj & G.anc);
  [i2, j2] = find(~(G.anc | G.anc' | logical(eye(n))));
  i_insert = [i1; i2];
  j_insert = [j1; j2];

  filt = ~ismember(j_insert, full_node);
  i_insert = i_insert(filt);
  j_insert = j_insert(filt);

  filt = ~ismember(i_delete, full_node);
  i_reverse = i_delete(filt);
  j_reverse = j_delete(filt);

  ndelete = length(i_delete);
  ninsert = length(i_insert);
  nreverse = length(i_reverse);

  G_new = G;
  while true
    move_type = randsample(3, 1, true, [ninsert, ndelete, nreverse]);
    if move_type == 1 % Insertion
      ind = randi(ninsert);
      G_new.adj(i_insert(ind), j_insert(ind)) = true;

      updated_ind = j_insert(ind);

      G_new.anc = adj2anc(G_new.adj);
      break;
    elseif move_type == 2 % Deletion
      ind = randi(ndelete);
      G_new.adj(i_delete(ind), j_delete(ind)) = false;

      updated_ind = j_delete(ind);

      G_new.anc = adj2anc(G_new.adj);
      break;
    else % Reversal
      ind = randi(nreverse);

      if ~any(G.anc(i_reverse(ind),G.adj(:,j_reverse(ind))))
        G_new.adj(i_reverse(ind), j_reverse(ind)) = false;
        G_new.adj(j_reverse(ind), i_reverse(ind)) = true;

        updated_ind = [i_reverse(ind), j_reverse(ind)];

        G_new.anc = adj2anc(G_new.adj);
        break;
      end
    end
  end

  logQ_ratio = 0;
end
