function [logp, logp_fam] = compute_marginal_likelihood(G, D1, I_mat1, D2, I_mat2, prior)
  if ~exist('prior', 'var')
    prior = {};
  end

  posterior1 = compute_posterior(G, D1, I_mat1, false, prior);
  posterior2 = compute_posterior(G, D2, I_mat2, false, posterior1);

  num_not_clamped = sum(size(I_mat2, 1) - sum(I_mat2));

  logp_fam = -.5 * (size(I_mat2, 1) - sum(I_mat2, 1)') * log(2 * pi);
  for j = 1:G.n
    logp_fam(j) = logp_fam(j) + .5 * (logdet(posterior1(j).lambda) - logdet(posterior2(j).lambda));
    logp_fam(j) = logp_fam(j) + posterior1(j).alpha * log(posterior1(j).beta);
    logp_fam(j) = logp_fam(j) - posterior2(j).alpha * log(posterior2(j).beta);
    logp_fam(j) = logp_fam(j) + gammaln(posterior2(j).alpha);
    logp_fam(j) = logp_fam(j) - gammaln(posterior1(j).alpha);
  end
  logp = sum(logp_fam);
end
