function posterior = compute_posterior(G, D, I_mat, inv_det_flag, prior)
  prior_flag = exist('prior', 'var') && ~isempty(prior);

  [m n] = size(D);

  posterior = repmat(struct('mu',[],'lambda',[],'alpha',[],'beta',[]), n, 1);
  for j = 1:n
    if isfield(G, 'order')
      nparent = G.rank(j) - 1;
    else
      nparent = sum(G.adj(:,j));
    end

    if prior_flag
      pri = prior(j);
    else
      pri = compute_prior_single(nparent);
    end

    if m == 0
      posterior(j) = pri;
    else
      [X_j, y_j] = get_family_specific_data(G, D, I_mat, j);
      posterior(j) = compute_posterior_for_family(X_j, y_j, pri);
    end
  end

  if inv_det_flag
    for j = 1:n
      posterior(j).lambda_inv = inv(posterior(j).lambda);
      posterior(j).lambda_logdet = logdet(posterior(j).lambda);
    end
  end
end
