function posterior = compute_posterior_for_family(X_j, y_j, prior)
  posterior = struct('mu', [], 'lambda', [], 'alpha', [], 'beta', []);
  posterior.lambda = X_j' * X_j + prior.lambda;
  posterior.mu = posterior.lambda \ (prior.lambda * prior.mu + X_j' * y_j);
  posterior.alpha = prior.alpha + size(X_j, 1) / 2;
  posterior.beta = prior.beta + .5 * (y_j' * y_j ...
                     + prior.mu' * prior.lambda * prior.mu ...
                     - posterior.mu' * posterior.lambda * posterior.mu);
end
