function [D, logp] = generate_data_from_gbn(gbn, I, m)
  for i = 1:length(I)
    gbn.param.W(:,I(i).var) = 0;
    gbn.param.mu(I(i).var) = I(i).val;
    gbn.param.sigma2(I(i).var) = 0;
  end
  [meanvec, covmatrix] = gbn2mvn(gbn.param.mu, gbn.param.sigma2, gbn.param.W);
  D = mvnrnd(meanvec', covmatrix, m);

  filt = ~I_list2mat(gbn.n, {I});
  logp = log(mvnpdf(D(:,filt), meanvec(filt)', covmatrix(filt,filt)));
end
