function gbn = learn_MAP_gbn_given_graph(G, D, I_mat, prior)
  if ~exist('prior', 'var')
    prior = {};
  end

  posterior = compute_posterior(G, D, I_mat, false, prior);

  gbn.n = G.n;
  if isfield(G, 'order')
    gbn.adj = order2adj(G.order);
  else
    gbn.adj = G.adj;
  end

  gbn.param = struct;
  gbn.param.mu = zeros(gbn.n, 1);
  gbn.param.sigma2 = zeros(gbn.n, 1);
  gbn.param.W = sparse(gbn.n, gbn.n);

  for j = 1:G.n
    if isfield(G, 'order')
      parent_inds = G.order(1:G.rank(j)-1);
    else
      parent_inds = find(G.adj(:,j));
    end

    gbn.param.mu(j) = posterior(j).mu(1);
    gbn.param.W(parent_inds, j) = posterior(j).mu(2:end);
    gbn.param.sigma2(j) = posterior(j).beta / (posterior(j).alpha + 1);
  end
end
